package com.jiuqi.util.tree;

import java.util.Iterator;
import java.util.Stack;

class TreeIterator implements Iterator {
   private Stack stack = new Stack();

   public TreeIterator(TreeNode root) {
      this.stack.push(new NodeStub(root, 0));
   }

   public boolean hasNext() {
      while(!this.stack.empty()) {
         NodeStub prev = (NodeStub)this.stack.peek();
         if (prev.next < prev.node.size()) {
            return true;
         }

         this.stack.pop();
      }

      return false;
   }

   public Object next() {
      while(!this.stack.empty()) {
         NodeStub prev = (NodeStub)this.stack.peek();
         if (prev.next < prev.node.size()) {
            TreeNode nextNode = prev.node.get(prev.next);
            if (nextNode.size() > 0) {
               this.stack.push(new NodeStub(nextNode, 0));
            }

            ++prev.next;
            return nextNode.getItem();
         }

         this.stack.pop();
      }

      return null;
   }

   public void remove() {
      throw new UnsupportedOperationException("树形枚举器不支持删除操作！");
   }

   private static class NodeStub {
      public TreeNode node = null;
      public int next = 0;

      public NodeStub(TreeNode node, int next) {
         this.node = node;
         this.next = next;
      }
   }
}
